package bbs.pool;
import java.util.*;


class BadConnKiller extends Thread {
	private Pool pool;
// thread  
private boolean shouldRun = true;
/**
 * BadConnKiller  ּ.
 */
public BadConnKiller(Pool pool) 
{
	
	super();

	this.pool = pool;

	if(pool.VERBOSE){
		System.out.println("bbs.pool.connpool2001.BadConnKiller.BadConnKiller(Pool, boolean), "
			+"200109101657 :: new BadConnKiller is created");
	}
	
}
 /**
 * Ǯ  Ŀؼǵ ˻ؼ 
 * ۼ ¥: (2001-09-10  4:44:13)
 */
synchronized private void killBadConn() 
{

	int cnt = Pool.BadConnKiller_FETCH_SIZE;

	Vector conns = new Vector(cnt);
	DBConnection conn = null;
		
	for(int i=0; i<cnt; i++){

		try{
			conn = pool.getConnection();

			if(pool.VERBOSE){
				System.out.println("bbs.pool.connpool2001.BadConnKiller.killBadConn(), "
					+"200109101701 :: badConnKiller thread got a connection("+i+")");
			}
			
			try{
				if(System.currentTimeMillis() - conn.getCreatedTime().getTime() 
					> Pool.CONN_ALIVE_TIME)
				{
					throw new Exception();
				}
				
				conn.getMetaData();
				conns.add(conn);
			}
			catch(Exception e){
				//  ° ׳ 	
			}
		}
		catch(Exception e){
			if(pool.VERBOSE){
				System.out.println(
					"Ex200109101650(bbs.pool.connpool2001.BadConnKiller.killBadConn())::"+e);
			}
		}
	}

	
	// ˻簡  Ŀؼǵ() 

	if(pool.VERBOSE){
		System.out.println("bbs.pool.connpool2001.BadConnKiller.killBadConn(), 200109101702 "
			+":: badConnKiller thread return tested connections(all "+conns.size()+")");
	}
	
	try{
		pool.returnConnections(conns);
	}
	catch(Exception e){
			if(pool.VERBOSE){
				System.out.println(
					"Ex200109101655(bbs.pool.connpool2001.BadConnKiller.killBadConn())::"+e);
			}
	}
	
	
}
/**
 * ޼ҵ  Ͻʽÿ.
 * ۼ ¥: (2001-09-10  4:36:09)
 */
public void run() 
{

	if(pool.VERBOSE){
		System.out.println("bbs.pool.connpool2001.BadConnKiller.run(), "
			+"200109101656 :: badConnKiller thread is started");
	}

	while(shouldRun){

		if(pool.VERBOSE){
			System.out.println("bbs.pool.connpool2001.BadConnKiller.run(), "
				+"200109101700 :: badConnKiller thread is running");
		}
		
		try{
			Thread.sleep(Pool.BadConnKiller_RUNNING_TERM);
		}
		catch(InterruptedException ignored){}

		killBadConn();
		
	}	
	

	if(pool.VERBOSE){
		System.out.println("bbs.pool.connpool2001.BadConnKiller.run(), "
			+"200109101655 :: badConnKiller thread is finished");
	}
	
}
}
