package bbs.pool;

public class PoolContainer extends java.util.Hashtable {
	private static PoolContainer instance;
	

	private boolean VERBOSE = false;

/**
 * PoolContainer  ּ.
 */
private PoolContainer() {
	super();

	if(isVERBOSE()){
		System.out.println("bbs.pool.connpool2001.PoolContainer.PoolContainer(), 200109071005 : "
			+"new PoolContainer is created");
	}
}
/**
 * pool container νϽ ش °  
 * ۼ ¥: (2001-09-06  6:00:45)
 * @return bbs.pool.connpool2001.PoolContainer
 */
synchronized public static PoolContainer getInstance() 
{

	if(PoolContainer.instance == null){
		PoolContainer.instance = new PoolContainer();
	}

	return PoolContainer.instance;
	
}
/**
 * pool container  ⺻ Ǯ ش.
 * ۼ ¥: (2001-09-07  9:40:58)
 * @return bbs.pool.connpool2001.Pool
 */
public Pool getPool()  throws Exception
{
	return getPool(null);
}
/**
 * pool container  ش id Ǯ ش.  ٸ  Ѵ.
 * ۼ ¥: (2001-09-07  9:11:58)
 * @return bbs.pool.connpool2001.Pool
 * @param id java.lang.String
 */
public Pool getPool(String id)  throws Exception
{

	Pool pool = null;
	if(id==null){
		id = Pool.DEFAULT_ID;
	}
	
	synchronized (this){
		if(size()>0){
			pool = (Pool)get(id);
		}

		// ش pool °  ؼ ̳ʿ ߰
		if(pool==null){
			pool = new Pool(id, this);
			put(id, pool);
		}
	}
	
	pool.setVERBOSE(isVERBOSE());	
	return pool;
}
/**
 * ޼ҵ  Ͻʽÿ.
 * ۼ ¥: (2001-09-07  9:56:36)
 * @return boolean
 */
public boolean isVERBOSE() {
	return VERBOSE;
}
/**
 * ޼ҵ  Ͻʽÿ.
 * ۼ ¥: (2001-09-07  9:56:36)
 * @param newVERBOSE boolean
 */
public void setVERBOSE(boolean newVERBOSE) {
	VERBOSE = newVERBOSE;
}
}
