package bbs.skin;

import java.io.*;
import java.util.*;

public class BoardSkin
{
	File f;
	BufferedReader bfr;
	
	String mainadmin_img;
	String admin_img;
	String login_img;
	String logout_img;
	String list_img;
	String write_img;
	String read_img;
	String modify_img;
	String reply_img;
	String delete_img;
	String next_img;
	String previous_img;
	String arrow_img;
	String file_img;
	String text_img;
	String fileadd_img;
	String filedelete_img;
	String boardback_img;
	String search_img;
	String save_img;
	String conform_img;
	String link_color;
	String hover_color;
	String active_color;
	String visited_color;
	String text_color;
	String title_color;
	//Blist.jsp
	String select_line_color;
	//Bread.jsp
	String read_subtitle_bg_color;
	String read_table_line_color;
	//Bwrite.jsp
	String write_subtitle_bg_color;
	String write_table_line_color;
	
	String readText;
	StringTokenizer stToken;
	String title;
	
	public BoardSkin(String FilePath)
	{
		try
		{
			f = new File(FilePath);
			bfr = new BufferedReader(new FileReader(f));
			init();
		}
		catch(Exception e)
		{
			System.out.println(e.toString());
		}
	}
	private void init() throws IOException
	{
		while((readText=bfr.readLine())!= null)
		{
			stToken = new StringTokenizer(readText,":");
			title = (String)stToken.nextElement();
			if(title.substring(0,2).equals("//")) continue; //ּκ
			
			if(title.equals("Main Admin Image"))
			{
				mainadmin_img = (String)stToken.nextElement();
			}
			else if(title.equals("Admin Image"))
			{
				admin_img = (String)stToken.nextElement();
			}
			else if(title.equals("Login Image"))
			{
				login_img = (String)stToken.nextElement();
			}
			else if(title.equals("Logout Image"))
			{
				logout_img = (String)stToken.nextElement();
			}
			else if(title.equals("List Image"))
			{
				list_img = (String)stToken.nextElement();
			}
			else if(title.equals("Write Image"))
			{
				write_img = (String)stToken.nextElement();
			}	
			else if(title.equals("Read Image"))
			{
				read_img = (String)stToken.nextElement();
			}	
			else if(title.equals("Modify Image"))
			{
				modify_img = (String)stToken.nextElement();
			}
			else if(title.equals("Reply Image"))
			{
				reply_img = (String)stToken.nextElement();
			}
			else if(title.equals("Delete Image"))
			{
				delete_img = (String)stToken.nextElement();
			}
			else if(title.equals("Next Image"))
			{
				next_img = (String)stToken.nextElement();
			}
			else if(title.equals("Previous Image"))
			{
				previous_img = (String)stToken.nextElement();
			}
			else if(title.equals("Arrow Image"))
			{
				arrow_img = (String)stToken.nextElement();
			}
			else if(title.equals("File Image"))
			{
				file_img = (String)stToken.nextElement();
			}
			else if(title.equals("Text Image"))
			{
				text_img = (String)stToken.nextElement();
			}
			else if(title.equals("File Add Image"))
			{
				fileadd_img = (String)stToken.nextElement();
			}
			else if(title.equals("File Delete Image"))
			{
				filedelete_img = (String)stToken.nextElement();
			}
			else if(title.equals("Search Image"))
			{
				search_img = (String)stToken.nextElement();
			}
			else if(title.equals("Save Image"))
			{
				save_img = (String)stToken.nextElement();
			}
			else if(title.equals("Board Back Image"))
			{
				boardback_img = (String)stToken.nextElement();
			}
			else if(title.equals("Conform Image"))
			{
				conform_img = (String)stToken.nextElement();
			}
			else if(title.equals("All Link Color"))
			{
				link_color = (String)stToken.nextElement();
			}
			else if(title.equals("All Hover Color"))
			{
				hover_color = (String)stToken.nextElement();
			}
			else if(title.equals("All Active Color"))
			{
				active_color = (String)stToken.nextElement();
			}
			else if(title.equals("All Visited Color"))
			{
				visited_color = (String)stToken.nextElement();
			}
			else if(title.equals("All Text Color"))
			{
				text_color = (String)stToken.nextElement();
			}
			else if(title.equals("All Title Color"))
			{
				title_color = (String)stToken.nextElement();
			}
			else if(title.equals("List Selected Line Color"))
			{
				select_line_color = (String)stToken.nextElement();
			}
			else if(title.equals("Read SubTitle Bg Color"))
			{
				read_subtitle_bg_color = (String)stToken.nextElement();
			}
			else if(title.equals("Read Table Line Color"))
			{
				read_table_line_color = (String)stToken.nextElement();
			}
			else if(title.equals("Write SubTitle Bg Color"))
			{
				write_subtitle_bg_color = (String)stToken.nextElement();
			}
			else if(title.equals("Write Table Line Color"))
			{
				write_table_line_color = (String)stToken.nextElement();
			}
		}
	}
	public String getMainAdminImg()
	{
		return mainadmin_img;
	}
	public String getAdminImg()
	{
		return admin_img;
	}
	public String getLoginImg()
	{
		return login_img;
	}
	public String getLogoutImg()
	{
		return logout_img;
	}
	public String getListImg()
	{
		return list_img;
	}
	public String getWriteImg()
	{
		return write_img;
	}
	public String getReadImg()
	{
		return read_img;
	}
	public String getModifyImg()
	{
		return modify_img;
	}
	public String getReplyImg()
	{
		return reply_img;
	}
	public String getDeleteImg()
	{
		return delete_img;
	}
	public String getNextImg()
	{
		return next_img;
	}
	public String getPreviousImg()
	{
		return previous_img;
	}
	public String getArrowImg()
	{
		return arrow_img;
	}
	public String getFileImg()
	{
		return file_img;
	}
	public String getTextImg()
	{
		return text_img;
	}
	public String getFileAddImg()
	{
		return fileadd_img;
	}
	public String getFileDeleteImg()
	{
		return filedelete_img;
	}
	public String getSearchImg()
	{
		return search_img;
	}
	public String getSaveImg()
	{
		return save_img;
	}
	public String getBoardBackImg()
	{
		return boardback_img;
	}
	public String getConformImg()
	{
		return conform_img;
	}
	public String getLinkColor()
	{
		return link_color;
	}
	public String getActiveColor()
	{
		return active_color;
	}
	public String getHoverColor()
	{
		return hover_color;
	}
	public String getVisitedColor()
	{
		return visited_color;
	}
	public String getTextColor()
	{
		return text_color;
	}
	public String getTitleColor()
	{
		return title_color;
	}
	public String getSelectLineColor()
	{
		return select_line_color;
	}
	public String getReadSubTitleBgColor()
	{
		return read_subtitle_bg_color;
	}
	public String getReadTableLineColor()
	{
		return read_table_line_color;
	}
	public String getWriteSubTitleBgColor()
	{
		return write_subtitle_bg_color;
	}
	public String getWriteTableLineColor()
	{
		return write_table_line_color;
	}
}

		
